﻿using Newtonsoft.Json.Linq;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace FeatureGuideCharp
{
    class _09_25_notary_signer
    {
        private String API_KEY = "your_api_key";
        private String API_URL = "https://sandbox.esignlive.com/api";

        private String notaryRoleId = "notary";
        private String notaryEmail = "notary_email";

        public void Execute() {

            EslClient eslClient = new EslClient(API_KEY, API_URL);

      
                //step1: add notary as signer and mark "notarized" for package
                DocumentPackage pkg1 = PackageBuilder.NewPackageNamed("Create Notary Package by .NET SDK - " + System.DateTime.Now)
                                                                .WithSigner(SignerBuilder.NewSignerWithEmail(notaryEmail)
                                                                        .WithFirstName("Duo")
                                                                        .WithLastName("Liang")
                                                                        .WithCustomId(notaryRoleId)
                                                                        )
                                                               .WithNotarized(true)
                                                               .WithSettings(DocumentPackageSettingsBuilder.NewDocumentPackageSettings()
                                                                                        .HideOwnerInPersonDropDown()
                                                                            )
                                                               .Build();

                PackageId createPackageOneStep = eslClient.CreatePackageOneStep(pkg1);
                Debug.WriteLine("package id: "+ createPackageOneStep);


                //step2: set notary role id (by custom REST method)
                setNotaryRoleId(createPackageOneStep.Id, notaryRoleId);

}

    

        private void setNotaryRoleId(String packageId, String notaryId) {
            HttpClient httpClient = new HttpClient();
            httpClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", API_KEY);
            httpClient.DefaultRequestHeaders.Add("Accept", "application/json");
            string updatePackageString = "{\"notaryRoleId\" : \"" + notaryId + "\"}";
            StringContent jsonUpdatePackageContent = new StringContent(updatePackageString, Encoding.UTF8, "application/json");

            var response = httpClient.PutAsync(new Uri(API_URL) + "/packages/" + packageId, jsonUpdatePackageContent).Result;
            if (!response.IsSuccessStatusCode)
            {
                throw new Exception(response.Content.ReadAsStringAsync().Result);
            }
        }



    }
}
